package itsu.mcpe.WorldEditorEX;

import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import cn.nukkit.item.Item;
import com.google.gson.Gson;

import cn.nukkit.Player;
import cn.nukkit.block.Block;
import cn.nukkit.command.Command;
import cn.nukkit.command.CommandSender;
import cn.nukkit.command.ConsoleCommandSender;
import cn.nukkit.level.Level;
import cn.nukkit.level.Location;
import cn.nukkit.plugin.PluginBase;
import cn.nukkit.utils.TextFormat;
import itsu.mcpe.WorldEditorEX.task.*;

public class WorldEditorEX extends PluginBase {

    private static WorldEditorEX instance;
    private Map<String, ServiceProvider> data = new HashMap<>();

    private Block set;

    @Override
    public void onEnable() {
        getLogger().info(TextFormat.GREEN + "Diaktifkan.");
        getLogger().info(TextFormat.YELLOW + "Plugin ini tunduk pada lisensi Jupiter (GPL v3.0).");
        getLogger().info(TextFormat.YELLOW + "Dikembangkan oleh Itsu (itsu020402). dimodifikasi oleh NoriDev.");

        new File("plugins/WorldEditorEX/").mkdirs();
        getServer().getPluginManager().registerEvents(new EventListener(), this);

        instance = this;
    }

    @SuppressWarnings({ "deprecation" })
    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String args[]) {

        Player player = null;
        Block block = null;

        Location loc1 = null;
        Location loc2 = null;
        Level level = null;

        int id = 0;
        int meta = 0;

        switch (command.getName()) {

        case "set":
            if (sender instanceof ConsoleCommandSender) {
                sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Jalankan dari dalam game.");
                return true;
            }

            player = (Player) sender;

            ArrayList<Block> blocks = new ArrayList<Block>();

            try {
                for (String text : args[0].split(",", 0)) {
                    Item item = Item.fromString(text);
                    blocks.add(Block.get(item.getId(), item.getDamage()));
                }
            } catch (IndexOutOfBoundsException e) {
                sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Masukkan ID blok.");
                return true;
            }

            level = player.getLevel();
            loc1 = getProvider(player).getLocation1();
            loc2 = getProvider(player).getLocation2();

            if (!getProvider(player).isEditing()) {
                if (blocks.size() != 0 && level != null && loc1 != null && loc2 != null) {
                    getServer().broadcastMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.YELLOW
                            + sender.getName() + "memulai perubahan pada dunia.");
                    getProvider(player).addTask("set", getServer().getScheduler()
                            .scheduleTask(new SetBlockRandomTask(blocks, level, (Player) sender, loc1, loc2)));


                } else {
                    sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Beberapa item tidak ditetapkan.");
                    return true;
                }

            } else {
                sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Proses lain sedang dilaksanakan.");
                return true;
            }

            return true;

        case "cut":
            if (sender instanceof ConsoleCommandSender) {
                sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Jalankan dari dalam game.");
                return true;
            }

            player = (Player) sender;

            try {

                block = Block.get(0, 0);
                level = player.getLevel();
                loc1 = getProvider(player).getLocation1();
                loc2 = getProvider(player).getLocation2();

                if (!getProvider(player).isEditing()) {
                    if (block != null && level != null && loc1 != null && loc2 != null) {
                        getServer().broadcastMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.YELLOW
                                + sender.getName() + "memulai perubahan pada dunia.");
                        getProvider(player).addTask("cut", getServer().getScheduler()
                                .scheduleTask(new SetBlockTask(block, level, (Player) sender, loc1, loc2)));

                    } else {
                        sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Beberapa item tidak ditetapkan.");
                        return true;
                    }

                    return true;

                } else {
                    sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Proses lain sedang dilaksanakan.");
                    return true;
                }

            } catch (IndexOutOfBoundsException e) {
                sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Masukkan ID blok.");
                return true;

            }

        case "replace":
            if (sender instanceof ConsoleCommandSender) {
                sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Jalankan dari dalam game.");
                return true;
            }

            player = (Player) sender;
            int id2 = 0;
            int meta2 = 0;
            Block to;

            try {
                if (args[0].contains(":")) {
                    String[] data = args[0].split(":");
                    id = Integer.parseInt(data[0]);
                    meta = Integer.parseInt(data[1]);

                } else {
                    id = Integer.parseInt(args[0]);
                }

                if (args[1].contains(":")) {
                    String[] data = args[1].split(":");
                    id2 = Integer.parseInt(data[0]);
                    meta2 = Integer.parseInt(data[1]);

                } else {
                    id2 = Integer.parseInt(args[1]);
                }

                block = Block.get(id, meta);
                to = Block.get(id2, meta2);
                level = player.getLevel();
                loc1 = getProvider(player).getLocation1();
                loc2 = getProvider(player).getLocation2();

                if (!getProvider(player).isEditing()) {
                    if (block != null && level != null && loc1 != null && loc2 != null) {
                        getServer().broadcastMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.YELLOW
                                + sender.getName() + "memulai perubahan pada dunia.");
                        getProvider(player).addTask("replace", getServer().getScheduler()
                                .scheduleTask(new ReplaceTask(to, block, level, (Player) sender, loc1, loc2)));

                    } else {
                        sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Beberapa item tidak ditetapkan.");
                        return true;
                    }

                } else {
                    sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Proses lain sedang dilaksanakan.");
                    return true;
                }

            } catch (IndexOutOfBoundsException e) {
                sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Masukkan ID blok.");
                return true;

            } catch (NumberFormatException e) {
                sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Masukkan nilai numerik untuk ID blok.");
                return true;
            }

            return true;

        case "copy":
            if (sender instanceof ConsoleCommandSender) {
                sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Jalankan dari dalam game.");
                return true;
            }

            player = (Player) sender;

            level = player.getLevel();
            loc1 = getProvider(player).getLocation1();
            loc2 = getProvider(player).getLocation2();

            if (!getProvider(player).isEditing()) {
                if (level != null && loc1 != null && loc2 != null) {
                    getServer().broadcastMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.YELLOW
                            + sender.getName() + "memprakarsai perubahan pada dunia.");
                    getProvider(player).addTask("copy",
                            getServer().getScheduler().scheduleTask(new CopyTask(level, (Player) sender, loc1, loc2)));

                } else {
                    sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Beberapa item tidak diatur.");
                    return true;
                }

            } else {
                sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Proses lain sedang dilaksanakan.");
                return true;
            }

            return true;

        case "paste":
            if (sender instanceof ConsoleCommandSender) {
                sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Jalankan dari dalam game.");
                return true;
            }

            player = (Player) sender;

            level = player.getLevel();
            loc1 = getProvider(player).getLocation1();
            loc2 = getProvider(player).getLocation2();

            if (!getProvider(player).isEditing()) {
                if (level != null && loc1 != null && loc2 != null && getProvider(player).getCopy() != null) {
                    getServer().broadcastMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.YELLOW
                            + sender.getName() + "memulai perubahan pada dunia.");
                    getProvider(player).addTask("paste", getServer().getScheduler().scheduleTask(
                            new PasteTask(level, player, player.getLocation(), getProvider(player).getCopy())));

                } else {
                    sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Beberapa item tidak diatur.");
                    return true;
                }

            } else {
                sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Proses lain sedang dilakukan.");
                return true;
            }

            return true;
            
        case "rotate":
        	if (sender instanceof ConsoleCommandSender) {
                sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Jalankan dari dalam game.");
                return true;
            }
        	
        	player = (Player) sender;
        	
        	if (!getProvider(player).isEditing()) {
                if (getProvider(player).getCopy() != null) {
                    player.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.YELLOW + "Mulai proses.");
                    getProvider(player).addTask("rotate", getServer().getScheduler().scheduleTask(new RotateTask(player, getProvider(player).getCopy())));

                } else {
                    sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Baiklah.");
                    return true;
                }

            } else {
                sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Proses lain sedang dilaksanakan.");
                return true;
            }
        	
        	return true;

        case "export":
            if (sender instanceof ConsoleCommandSender) {
                sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Jalankan dari dalam game.");
                return true;
            }

            try {
                player = (Player) sender;
                sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.YELLOW + "Mengekspor...");
                getServer().getScheduler()
                        .scheduleTask(new ExportTask(new File("plugins/WorldEditorEX/" + args[0] + ".json"),
                                new Gson().toJson(getProvider(player).getCopy()).getBytes()));
                sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.AQUA + "Output selesai.");
                return true;
                
            } catch (IndexOutOfBoundsException e) {
                sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Masukkan nama ekspor.");
                return true;
            }

        case "import":
            if (sender instanceof ConsoleCommandSender) {
                sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Jalankan dari dalam game.");
                return true;
            }

            player = (Player) sender;
            sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.YELLOW + "Mengimpor selama ...");
            getProvider(player).addTask("import", getServer().getScheduler()
                    .scheduleTask(new ImportTask(player, new File("plugins/WorldEditorEX/" + args[0] + ".json"))));
            return true;

        case "xyz":
            if (sender instanceof ConsoleCommandSender) {
                sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Jalankan dari dalam game.");
                return true;
                
            } else {
                player = (Player) sender;
                sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RESET + "Koordinat saat ini: (" + player.getX()
                        + ", " + player.getY() + ", " + player.getZ() + ")");
                return true;
            }

        case "bid":
            if (sender instanceof ConsoleCommandSender) {
                sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Jalankan dari dalam game.");
                return true;
                
            } else {
                player = (Player) sender;
                sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RESET + "ID barang: "
                        + player.getInventory().getItemInHand().getId() + ":"
                        + player.getInventory().getItemInHand().getDamage());
                return true;
            }

        case "objects":
            File[] files = new File("plugins/WorldEditorEX/").listFiles();
            sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.YELLOW + "File yang dapat diimpor :. ");
            for (File file : files) {
                if (!file.isDirectory() && file.getName().endsWith(".json")) {
                    sender.sendMessage(TextFormat.LIGHT_PURPLE + file.getName().replaceAll(".json", ""));
                }
            }
            return true;
            
        case "pos1":
        	if (sender instanceof ConsoleCommandSender) {
                sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Jalankan dari dalam game.");
                return true;
            }
        	
        	player = (Player) sender;
        	
        	WorldEditorEX.getInstance().getProvider(player).setLocation1(player.getLocation(), player.getLevel());
			player.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RESET + "Poin 1 sudah ditetapkan.");
			player.getPlayer().sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RESET + "mengkoordinasikan: (" + player.getX() + ", " + player.getY() + ", " + player.getZ() + ")");
			EventListener.calculateBlockCount(player);
			return true;
			
        case "pos2":
        	if (sender instanceof ConsoleCommandSender) {
                sender.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RED + "Jalankan dari dalam game.");
                return true;
            }
        	
        	player = (Player) sender;
        	
        	WorldEditorEX.getInstance().getProvider(player).setLocation2(player.getLocation(), player.getLevel());
			player.sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RESET + "Titik 2 sudah disiapkan.");
			player.getPlayer().sendMessage(TextFormat.GREEN + "[NWorldEditor] " + TextFormat.RESET + "mengkoordinasikan: (" + player.getX() + ", " + player.getY() + ", " + player.getZ() + ")");
			EventListener.calculateBlockCount(player);
			return true;
        	

        case "wehelp":
            help(sender);
            return true;
        }

        return true;
    }

    public static WorldEditorEX getInstance() {
        return instance;
    }

    public void addPlayer(Player player) {
        if (!data.containsKey(player.getName())) {
            data.put(player.getName(), new ServiceProvider());
        }
    }

    public void removePlayer(Player player) {
        if (data.containsKey(player.getName())) {
            data.remove(player.getName());
        }
    }

    public ServiceProvider getProvider(Player player) {
        return data.get(player.getName());
    }

    private void help(CommandSender sender) {
        StringBuffer bf = new StringBuffer();
        bf.append(TextFormat.GREEN + "[NWorldEditor] bantuan NWorldEditor\n");
        bf.append(TextFormat.YELLOW + "perintah\n");
        bf.append(TextFormat.AQUA + "/pos1 " + TextFormat.WHITE + "Tentukan pilihan 1.\n");
        bf.append(TextFormat.AQUA + "/pos2 " + TextFormat.WHITE + "Tentukan pilihan 2.\n");
        bf.append(TextFormat.AQUA + "/set [id:meta] " + TextFormat.WHITE + "Mengisi rentang yang ditentukan dengan blok dari [id:meta] yang ditentukan. Jika tidak ada blok yang ditentukan dalam argumen, blok dari /set sebelumnya akan digunakan.\n");
        bf.append(TextFormat.AQUA + "/cut " + TextFormat.WHITE + "Menghapus rentang blok tertentu sekaligus.\n");
        bf.append(TextFormat.AQUA + "/replace [id:meta] [id:meta] " + TextFormat.WHITE + "Mengganti blok [id:meta] pertama yang ditentukan dengan blok [id:meta] kedua.\n");
        bf.append(TextFormat.AQUA + "/copy " + TextFormat.WHITE + "Menyalin blok dalam rentang yang ditentukan.\n");
        bf.append(TextFormat.AQUA + "/paste " + TextFormat.WHITE + "Rekatkan blok yang disalin dengan mengacu pada titik di mana Anda berada saat ini.\n");
        bf.append(TextFormat.AQUA + "/rotate " + TextFormat.WHITE + "Putar blok yang disalin sebesar 90°.\n");
        bf.append(TextFormat.AQUA + "/export [nama-file] " + TextFormat.WHITE + "Simpan blok yang disalin dalam file di bawah [nama file].\n");
        bf.append(TextFormat.AQUA + "/import [nama-file] " + TextFormat.WHITE + "Muat blok [nama file] yang disimpan. Setelah pemuatan selesai, Anda dapat menempelkan dengan /paste.\n");
        bf.append(TextFormat.AQUA + "/xyz " + TextFormat.WHITE + "Menampilkan koordinat saat ini.\n");
        bf.append(TextFormat.AQUA + "/bid " + TextFormat.WHITE + "Menampilkan ID item yang ada di tangan Anda.\n");
        bf.append(TextFormat.AQUA + "/objects " + TextFormat.WHITE + "Menampilkan daftar nama file yang dapat diimpor.\n");
        bf.append(TextFormat.AQUA + "/wehelp " + TextFormat.WHITE + "Lihat bantuan ini.\n");
        bf.append(TextFormat.YELLOW + "Cara menentukan rentang\n");
        bf.append(TextFormat.WHITE + "Titik 1 adalah tempat Anda menghancurkan balok dengan kapak kayu (juga dapat dilakukan dengan perintah /pos1), dan titik 2 adalah tempat Anda mengetuk balok yang sama (juga dapat dilakukan dengan perintah /pos2).\n");
        bf.append(TextFormat.YELLOW + "Lainnya.\n");
        bf.append(TextFormat.AQUA + "Pengembang: " + TextFormat.WHITE + "Itsu(itsu020402)/"
                + TextFormat.AQUA + "versi: " + TextFormat.WHITE + this.getDescription().getVersion()
                + TextFormat.LIGHT_PURPLE + "\nWorldEditorEX for Jupiter/Nukkit LICENSE:GPL-v3.0 Itsu Java OpenSource Project");

        sender.sendMessage(bf.toString());
    }

}
